package com.link.core.contextholder;

import com.link.core.util.RedisUtil;
import com.link.core.util.redisclient.LinkRedisClient;
import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentLinkedQueue;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.CollectionUtils;
import org.springframework.web.context.request.RequestContextHolder;

public class RedisSecurityContextHolderbAK {

   private static Logger logger = LoggerFactory.getLogger(RedisSecurityContextHolderbAK.class);
   private static final String FUNCTION = "function";
   private static final String P1 = "p1";
   private static final String P2 = "p2";
   private static final String P3 = "p3";
   private static final String P4 = "p4";
   private static final String P5 = "p5";
   private static final String REDIS_CONTEXT_ATTRIBUTES = "REDIS_SECURITY_CONTEXT";


   public static void set(RedisSecurityContextHolderbAK.LkRdsFunctionP0 function) {
      ConcurrentLinkedQueue functions = get();
      if(CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      HashMap parmas = new HashMap(2);
      parmas.put("function", function);
      functions.add(parmas);
   }

   public static void set(RedisSecurityContextHolderbAK.LkRdsFunctionP1 function, Object p1) {
      ConcurrentLinkedQueue functions = get();
      if(CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      HashMap parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      functions.add(parmas);
   }

   public static void set(RedisSecurityContextHolderbAK.LkRdsFunctionP2 function, Object p1, Object p2) {
      ConcurrentLinkedQueue functions = get();
      if(CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      HashMap parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      functions.add(parmas);
   }

   public static void set(RedisSecurityContextHolderbAK.LkRdsFunctionP3 function, Object p1, Object p2, Object p3) {
      ConcurrentLinkedQueue functions = get();
      if(CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      HashMap parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      parmas.put("p3", p3);
      functions.add(parmas);
   }

   public static void set(RedisSecurityContextHolderbAK.LkRdsFunctionP4 function, Object p1, Object p2, Object p3, Object p4) {
      ConcurrentLinkedQueue functions = get();
      if(CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      HashMap parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      parmas.put("p3", p3);
      parmas.put("p4", p4);
      functions.add(parmas);
   }

   public static void set(RedisSecurityContextHolderbAK.LkRdsFunctionP5 function, Object p1, Object p2, Object p3, Object p4, Object p5) {
      ConcurrentLinkedQueue functions = get();
      if(CollectionUtils.isEmpty(functions)) {
         functions = new ConcurrentLinkedQueue();
         RequestContextHolder.currentRequestAttributes().setAttribute("REDIS_SECURITY_CONTEXT", functions, 0);
      }

      HashMap parmas = new HashMap(2);
      parmas.put("function", function);
      parmas.put("p1", p1);
      parmas.put("p2", p2);
      parmas.put("p3", p3);
      parmas.put("p4", p4);
      parmas.put("p5", p5);
      functions.add(parmas);
   }

   private static ConcurrentLinkedQueue get() {
      return (ConcurrentLinkedQueue)RequestContextHolder.currentRequestAttributes().getAttribute("REDIS_SECURITY_CONTEXT", 0);
   }

   public static void roolBack() {
      ConcurrentLinkedQueue functions = get();
      if(!CollectionUtils.isEmpty(functions)) {
         LinkRedisClient redisClient = null;

         try {
            for(redisClient = RedisUtil.getJedis(); !functions.isEmpty(); functions.remove()) {
               Map e = (Map)functions.peek();
               Object functionMap1 = e.get("function");
               if(functionMap1 instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP0) {
                  ((RedisSecurityContextHolderbAK.LkRdsFunctionP0)functionMap1).accept(redisClient);
               }

               if(functionMap1 instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP1) {
                  ((RedisSecurityContextHolderbAK.LkRdsFunctionP1)functionMap1).accept(redisClient, e.get("p1"));
               }

               if(functionMap1 instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP2) {
                  ((RedisSecurityContextHolderbAK.LkRdsFunctionP2)functionMap1).accept(redisClient, e.get("p1"), e.get("p2"));
               }

               if(functionMap1 instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP3) {
                  ((RedisSecurityContextHolderbAK.LkRdsFunctionP3)functionMap1).accept(redisClient, e.get("p1"), e.get("p2"), e.get("p3"));
               }

               if(functionMap1 instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP4) {
                  ((RedisSecurityContextHolderbAK.LkRdsFunctionP4)functionMap1).accept(redisClient, e.get("p1"), e.get("p2"), e.get("p3"), e.get("p4"));
               }

               if(functionMap1 instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP5) {
                  ((RedisSecurityContextHolderbAK.LkRdsFunctionP5)functionMap1).accept(redisClient, e.get("p1"), e.get("p2"), e.get("p3"), e.get("p4"), e.get("p5"));
               }
            }
         } catch (Exception var8) {
            logger.error("回滚redis错误：" + var8.getMessage());
            logger.info("还没有进行回滚的操作有以下内容：");

            for(; !functions.isEmpty(); functions.remove()) {
               Map functionMap = (Map)functions.peek();
               Object function = functionMap.get("function");
               if(function instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP0) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP0");
               }

               if(function instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP1) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP1, 参数：" + functionMap.get("p1"));
               }

               if(function instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP2) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP2, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2"));
               }

               if(function instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP3) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP3, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2") + "," + functionMap.get("p3"));
               }

               if(function instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP4) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP4, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2") + "," + functionMap.get("p3") + "," + functionMap.get("p4"));
               }

               if(function instanceof RedisSecurityContextHolderbAK.LkRdsFunctionP5) {
                  logger.info("还没有进行回滚的操作有以下内容：方法：LkRdsFunctionP5, 参数：" + functionMap.get("p1") + "," + functionMap.get("p2") + "," + functionMap.get("p3") + "," + functionMap.get("p4") + "," + functionMap.get("p5"));
               }
            }

            throw var8;
         } finally {
            RedisUtil.returnResource(redisClient);
         }

      }
   }


   @FunctionalInterface
   public interface LkRdsFunctionP5 {

      Object accept(LinkRedisClient var1, Object var2, Object var3, Object var4, Object var5, Object var6);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP4 {

      Object accept(LinkRedisClient var1, Object var2, Object var3, Object var4, Object var5);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP3 {

      Object accept(LinkRedisClient var1, Object var2, Object var3, Object var4);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP2 {

      Object accept(LinkRedisClient var1, Object var2, Object var3);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP1 {

      Object accept(LinkRedisClient var1, Object var2);
   }

   @FunctionalInterface
   public interface LkRdsFunctionP0 {

      Object accept(LinkRedisClient var1);
   }
}
